// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from marine_sensor_msgs:msg/RadarEcho.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "marine_sensor_msgs/msg/detail/radar_echo__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace marine_sensor_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void RadarEcho_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) marine_sensor_msgs::msg::RadarEcho(_init);
}

void RadarEcho_fini_function(void * message_memory)
{
  auto typed_message = static_cast<marine_sensor_msgs::msg::RadarEcho *>(message_memory);
  typed_message->~RadarEcho();
}

size_t size_function__RadarEcho__echoes(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<float> *>(untyped_member);
  return member->size();
}

const void * get_const_function__RadarEcho__echoes(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<float> *>(untyped_member);
  return &member[index];
}

void * get_function__RadarEcho__echoes(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<float> *>(untyped_member);
  return &member[index];
}

void fetch_function__RadarEcho__echoes(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const float *>(
    get_const_function__RadarEcho__echoes(untyped_member, index));
  auto & value = *reinterpret_cast<float *>(untyped_value);
  value = item;
}

void assign_function__RadarEcho__echoes(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<float *>(
    get_function__RadarEcho__echoes(untyped_member, index));
  const auto & value = *reinterpret_cast<const float *>(untyped_value);
  item = value;
}

void resize_function__RadarEcho__echoes(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<float> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember RadarEcho_message_member_array[1] = {
  {
    "echoes",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_FLOAT,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(marine_sensor_msgs::msg::RadarEcho, echoes),  // bytes offset in struct
    nullptr,  // default value
    size_function__RadarEcho__echoes,  // size() function pointer
    get_const_function__RadarEcho__echoes,  // get_const(index) function pointer
    get_function__RadarEcho__echoes,  // get(index) function pointer
    fetch_function__RadarEcho__echoes,  // fetch(index, &value) function pointer
    assign_function__RadarEcho__echoes,  // assign(index, value) function pointer
    resize_function__RadarEcho__echoes  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers RadarEcho_message_members = {
  "marine_sensor_msgs::msg",  // message namespace
  "RadarEcho",  // message name
  1,  // number of fields
  sizeof(marine_sensor_msgs::msg::RadarEcho),
  RadarEcho_message_member_array,  // message members
  RadarEcho_init_function,  // function to initialize message memory (memory has to be allocated)
  RadarEcho_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t RadarEcho_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &RadarEcho_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace marine_sensor_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<marine_sensor_msgs::msg::RadarEcho>()
{
  return &::marine_sensor_msgs::msg::rosidl_typesupport_introspection_cpp::RadarEcho_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, marine_sensor_msgs, msg, RadarEcho)() {
  return &::marine_sensor_msgs::msg::rosidl_typesupport_introspection_cpp::RadarEcho_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
