// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from marine_sensor_msgs:msg/RadarSector.idl
// generated code does not contain a copyright notice

#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__BUILDER_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "marine_sensor_msgs/msg/detail/radar_sector__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace marine_sensor_msgs
{

namespace msg
{

namespace builder
{

class Init_RadarSector_intensities
{
public:
  explicit Init_RadarSector_intensities(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  ::marine_sensor_msgs::msg::RadarSector intensities(::marine_sensor_msgs::msg::RadarSector::_intensities_type arg)
  {
    msg_.intensities = std::move(arg);
    return std::move(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_range_max
{
public:
  explicit Init_RadarSector_range_max(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_intensities range_max(::marine_sensor_msgs::msg::RadarSector::_range_max_type arg)
  {
    msg_.range_max = std::move(arg);
    return Init_RadarSector_intensities(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_range_min
{
public:
  explicit Init_RadarSector_range_min(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_range_max range_min(::marine_sensor_msgs::msg::RadarSector::_range_min_type arg)
  {
    msg_.range_min = std::move(arg);
    return Init_RadarSector_range_max(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_scan_time
{
public:
  explicit Init_RadarSector_scan_time(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_range_min scan_time(::marine_sensor_msgs::msg::RadarSector::_scan_time_type arg)
  {
    msg_.scan_time = std::move(arg);
    return Init_RadarSector_range_min(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_time_increment
{
public:
  explicit Init_RadarSector_time_increment(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_scan_time time_increment(::marine_sensor_msgs::msg::RadarSector::_time_increment_type arg)
  {
    msg_.time_increment = std::move(arg);
    return Init_RadarSector_scan_time(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_angle_increment
{
public:
  explicit Init_RadarSector_angle_increment(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_time_increment angle_increment(::marine_sensor_msgs::msg::RadarSector::_angle_increment_type arg)
  {
    msg_.angle_increment = std::move(arg);
    return Init_RadarSector_time_increment(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_angle_start
{
public:
  explicit Init_RadarSector_angle_start(::marine_sensor_msgs::msg::RadarSector & msg)
  : msg_(msg)
  {}
  Init_RadarSector_angle_increment angle_start(::marine_sensor_msgs::msg::RadarSector::_angle_start_type arg)
  {
    msg_.angle_start = std::move(arg);
    return Init_RadarSector_angle_increment(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

class Init_RadarSector_header
{
public:
  Init_RadarSector_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_RadarSector_angle_start header(::marine_sensor_msgs::msg::RadarSector::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_RadarSector_angle_start(msg_);
  }

private:
  ::marine_sensor_msgs::msg::RadarSector msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::marine_sensor_msgs::msg::RadarSector>()
{
  return marine_sensor_msgs::msg::builder::Init_RadarSector_header();
}

}  // namespace marine_sensor_msgs

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__RADAR_SECTOR__BUILDER_HPP_
