// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from marine_sensor_msgs:msg/TurbidityNTU.idl
// generated code does not contain a copyright notice

#ifndef MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__STRUCT_HPP_
#define MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__marine_sensor_msgs__msg__TurbidityNTU __attribute__((deprecated))
#else
# define DEPRECATED__marine_sensor_msgs__msg__TurbidityNTU __declspec(deprecated)
#endif

namespace marine_sensor_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TurbidityNTU_
{
  using Type = TurbidityNTU_<ContainerAllocator>;

  explicit TurbidityNTU_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ntu = 0.0f;
    }
  }

  explicit TurbidityNTU_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->ntu = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _ntu_type =
    float;
  _ntu_type ntu;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__ntu(
    const float & _arg)
  {
    this->ntu = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> *;
  using ConstRawPtr =
    const marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__marine_sensor_msgs__msg__TurbidityNTU
    std::shared_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__marine_sensor_msgs__msg__TurbidityNTU
    std::shared_ptr<marine_sensor_msgs::msg::TurbidityNTU_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TurbidityNTU_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->ntu != other.ntu) {
      return false;
    }
    return true;
  }
  bool operator!=(const TurbidityNTU_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TurbidityNTU_

// alias to use template instance with default allocator
using TurbidityNTU =
  marine_sensor_msgs::msg::TurbidityNTU_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace marine_sensor_msgs

#endif  // MARINE_SENSOR_MSGS__MSG__DETAIL__TURBIDITY_NTU__STRUCT_HPP_
